Index: src/atom_trajectoryparticle.cpp
===================================================================
--- src/atom_trajectoryparticle.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_trajectoryparticle.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * atom_trajectoryparticle.cpp
@@ -6,4 +13,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,9 +24,9 @@
 #include "config.hpp"
 #include "element.hpp"
-#include "info.hpp"
-#include "log.hpp"
+#include "Helpers/Info.hpp"
+#include "Helpers/Log.hpp"
 #include "parser.hpp"
 #include "ThermoStatContainer.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 
 /** Constructor of class TrajectoryParticle.
@@ -30,14 +42,14 @@
 };
 
+/**
+ *  returns the kinetic energy of this atom at a given time step
+ */
+double TrajectoryParticle::getKineticEnergy(unsigned int step) const{
+  return getType()->getMass() * Trajectory.U.at(step).NormSquared();
+}
 
-/** Adds kinetic energy of this atom to given temperature value.
- * \param *temperature add on this value
- * \param step given step of trajectory to add
- */
-void TrajectoryParticle::AddKineticToTemperature(double *temperature, int step) const
-{
-  for (int i=NDIM;i--;)
-    *temperature += type->mass * Trajectory.U.at(step)[i]* Trajectory.U.at(step)[i];
-};
+Vector TrajectoryParticle::getMomentum(unsigned int step) const{
+  return getType()->getMass()*Trajectory.U.at(step);
+}
 
 /** Evaluates some constraint potential if atom moves from \a startstep at once to \endstep in trajectory.
@@ -54,17 +66,4 @@
   for (int i=NDIM;i++;)
     Force->Matrix[0][nr][5+i] += 2.*constant*sqrt(Trajectory.R.at(startstep).distance(Sprinter->Trajectory.R.at(endstep)));
-};
-
-/** Correct velocity against the summed \a CoGVelocity for \a step.
- * \param *ActualTemp sum up actual temperature meanwhile
- * \param Step MD step in atom::Tracjetory
- * \param *CoGVelocity remnant velocity (i.e. vector sum of all atom velocities)
- */
-void TrajectoryParticle::CorrectVelocity(double *ActualTemp, int Step, Vector *CoGVelocity)
-{
-  for(int d=0;d<NDIM;d++) {
-    Trajectory.U.at(Step)[d] -= CoGVelocity->at(d);
-    *ActualTemp += 0.5 * type->mass * Trajectory.U.at(Step)[d] * Trajectory.U.at(Step)[d];
-  }
 };
 
@@ -113,10 +112,10 @@
     Trajectory.R.at(NextStep)[d] = Trajectory.R.at(NextStep-1)[d];
     Trajectory.R.at(NextStep)[d] += configuration->Deltat*(Trajectory.U.at(NextStep-1)[d]);     // s(t) = s(0) + v * deltat + 1/2 a * deltat^2
-    Trajectory.R.at(NextStep)[d] += 0.5*configuration->Deltat*configuration->Deltat*(Trajectory.F.at(NextStep)[d]/type->mass);     // F = m * a and s =
+    Trajectory.R.at(NextStep)[d] += 0.5*configuration->Deltat*configuration->Deltat*(Trajectory.F.at(NextStep)[d]/getType()->getMass());     // F = m * a and s =
   }
   // Update U
   for (int d=0; d<NDIM; d++) {
     Trajectory.U.at(NextStep)[d] = Trajectory.U.at(NextStep-1)[d];
-    Trajectory.U.at(NextStep)[d] += configuration->Deltat * (Trajectory.F.at(NextStep)[d]+Trajectory.F.at(NextStep-1)[d]/type->mass); // v = F/m * t
+    Trajectory.U.at(NextStep)[d] += configuration->Deltat * (Trajectory.F.at(NextStep)[d]+Trajectory.F.at(NextStep-1)[d]/getType()->getMass()); // v = F/m * t
   }
   // Update R (and F)
@@ -130,133 +129,16 @@
 };
 
-/** Sums up mass and kinetics.
- * \param Step step to sum for
- * \param *TotalMass pointer to total mass sum
- * \param *TotalVelocity pointer to tota velocity sum
- */
-void TrajectoryParticle::SumUpKineticEnergy( int Step, double *TotalMass, Vector *TotalVelocity ) const
+std::ostream & TrajectoryParticle::operator << (std::ostream &ost) const
 {
-  *TotalMass += type->mass;  // sum up total mass
-  for(int d=0;d<NDIM;d++) {
-    TotalVelocity->at(d) += Trajectory.U.at(Step)[d]*type->mass;
-  }
-};
+  ParticleInfo::operator<<(ost);
+  ost << "," << getPosition();
+  return ost;
+}
 
-/** Scales velocity of atom according to Woodcock thermostat.
- * \param ScaleTempFactor factor to scale the velocities with (i.e. sqrt of energy scale factor)
- * \param Step MD step to scale
- * \param *ekin sum of kinetic energy
- */
-void TrajectoryParticle::Thermostat_Woodcock(double ScaleTempFactor, int Step, double *ekin)
+std::ostream & operator << (std::ostream &ost, const TrajectoryParticle &a)
 {
-  Vector &U = Trajectory.U.at(Step);
-  if (FixedIon == 0) // even FixedIon moves, only not by other's forces
-    for (int d=0; d<NDIM; d++) {
-      U[d] *= ScaleTempFactor;
-      *ekin += 0.5*type->mass * U[d]*U[d];
-    }
-};
+  a.ParticleInfo::operator<<(ost);
+  ost << "," << a.getPosition();
+  return ost;
+}
 
-/** Scales velocity of atom according to Gaussian thermostat.
- * \param Step MD step to scale
- * \param *G
- * \param *E
- */
-void TrajectoryParticle::Thermostat_Gaussian_init(int Step, double *G, double *E)
-{
-  Vector &U = Trajectory.U.at(Step);
-  Vector &F = Trajectory.F.at(Step);
-  if (FixedIon == 0) // even FixedIon moves, only not by other's forces
-    for (int d=0; d<NDIM; d++) {
-      *G += U[d] * F[d];
-      *E += U[d]*U[d]*type->mass;
-    }
-};
-
-/** Determines scale factors according to Gaussian thermostat.
- * \param Step MD step to scale
- * \param GE G over E ratio
- * \param *ekin sum of kinetic energy
- * \param *configuration configuration class with TempFrequency and TargetTemp
- */
-void TrajectoryParticle::Thermostat_Gaussian_least_constraint(int Step, double G_over_E, double *ekin, config *configuration)
-{
-  Vector &U = Trajectory.U.at(Step);
-  if (FixedIon == 0) // even FixedIon moves, only not by other's forces
-    for (int d=0; d<NDIM; d++) {
-      U[d] += configuration->Deltat/type->mass * ( (G_over_E) * (U[d]*type->mass) );
-      *ekin += type->mass * U[d]*U[d];
-    }
-};
-
-/** Scales velocity of atom according to Langevin thermostat.
- * \param Step MD step to scale
- * \param *r random number generator
- * \param *ekin sum of kinetic energy
- * \param *configuration configuration class with TempFrequency and TargetTemp
- */
-void TrajectoryParticle::Thermostat_Langevin(int Step, gsl_rng * r, double *ekin, config *configuration)
-{
-  double sigma  = sqrt(configuration->Thermostats->TargetTemp/type->mass); // sigma = (k_b T)/m (Hartree/atomicmass = atomiclength/atomictime)
-  Vector &U = Trajectory.U.at(Step);
-  if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
-    // throw a dice to determine whether it gets hit by a heat bath particle
-    if (((((rand()/(double)RAND_MAX))*configuration->Thermostats->TempFrequency) < 1.)) {
-      DoLog(3) && (Log() << Verbose(3) << "Particle " << *this << " was hit (sigma " << sigma << "): " << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << " -> ");
-      // pick three random numbers from a Boltzmann distribution around the desired temperature T for each momenta axis
-      for (int d=0; d<NDIM; d++) {
-        U[d] = gsl_ran_gaussian (r, sigma);
-      }
-      DoLog(2) && (Log() << Verbose(2) << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << endl);
-    }
-    for (int d=0; d<NDIM; d++)
-      *ekin += 0.5*type->mass * U[d]*U[d];
-  }
-};
-
-/** Scales velocity of atom according to Berendsen thermostat.
- * \param Step MD step to scale
- * \param ScaleTempFactor factor to scale energy (not velocity!) with
- * \param *ekin sum of kinetic energy
- * \param *configuration configuration class with TempFrequency and Deltat
- */
-void TrajectoryParticle::Thermostat_Berendsen(int Step, double ScaleTempFactor, double *ekin, config *configuration)
-{
-  Vector &U = Trajectory.U.at(Step);
-  if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
-    for (int d=0; d<NDIM; d++) {
-      U[d] *= sqrt(1+(configuration->Deltat/configuration->Thermostats->TempFrequency)*(ScaleTempFactor-1));
-      *ekin += 0.5*type->mass * U[d]*U[d];
-    }
-  }
-};
-
-/** Initializes current run of NoseHoover thermostat.
- * \param Step MD step to scale
- * \param *delta_alpha additional sum of kinetic energy on return
- */
-void TrajectoryParticle::Thermostat_NoseHoover_init(int Step, double *delta_alpha)
-{
-  Vector &U = Trajectory.U.at(Step);
-  if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
-    for (int d=0; d<NDIM; d++) {
-      *delta_alpha += U[d]*U[d]*type->mass;
-    }
-  }
-};
-
-/** Initializes current run of NoseHoover thermostat.
- * \param Step MD step to scale
- * \param *ekin sum of kinetic energy
- * \param *configuration configuration class with TempFrequency and Deltat
- */
-void TrajectoryParticle::Thermostat_NoseHoover_scale(int Step, double *ekin, config *configuration)
-{
-  Vector &U = Trajectory.U.at(Step);
-  if (FixedIon == 0) { // even FixedIon moves, only not by other's forces
-    for (int d=0; d<NDIM; d++) {
-        U[d] += configuration->Deltat/type->mass * (configuration->Thermostats->alpha * (U[d] * type->mass));
-        *ekin += (0.5*type->mass) * U[d]*U[d];
-      }
-  }
-};
Index: src/atom_trajectoryparticle.hpp
===================================================================
--- src/atom_trajectoryparticle.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_trajectoryparticle.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -20,5 +20,4 @@
 #include <fstream>
 
-#include <gsl/gsl_inline.h>
 #include <gsl/gsl_randist.h>
 
@@ -44,7 +43,5 @@
 
   // constraint potential and dynamics stuff
-  void AddKineticToTemperature(double *temperature, int step) const;
   void EvaluateConstrainedForce(int startstep, int endstep, atom **PermutationMap, ForceMatrix *Force) const;
-  void CorrectVelocity(double *ActualTemp, int Step, Vector *CoGVelocity);
 
   // trajectory stuff
@@ -52,19 +49,13 @@
   void CopyStepOnStep(int dest, int src);
   void VelocityVerletUpdate(int MDSteps, config *configuration, ForceMatrix *Force, const size_t offset);
-  void SumUpKineticEnergy( int Step, double *TotalMass, Vector *TotalVelocity ) const;
+  double getKineticEnergy(unsigned int step) const;
+  Vector getMomentum(unsigned int step) const;
 
-  // thermostats
-  void Thermostat_Woodcock(double ScaleTempFactor, int Step, double *ekin);
-  void Thermostat_Gaussian_init(int Step, double *G, double *E);
-  void Thermostat_Gaussian_least_constraint(int Step, double G_over_E, double *ekin, config *configuration);
-  void Thermostat_Langevin(int Step, gsl_rng * r, double *ekin, config *configuration);
-  void Thermostat_Berendsen(int Step, double ScaleTempFactor, double *ekin, config *configuration);
-  void Thermostat_NoseHoover_init(int Step, double *delta_alpha);
-  void Thermostat_NoseHoover_scale(int Step, double *ekin, config *configuration);
+  std::ostream & operator << (std::ostream &ost) const;
 
 private:
-
 };
 
+ostream & operator << (ostream &ost, const TrajectoryParticle &a);
 
 #endif /* ATOM_TRAJECTORYPARTICLE_HPP_ */
Index: src/atom_trajectoryparticleinfo.cpp
===================================================================
--- src/atom_trajectoryparticleinfo.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_trajectoryparticleinfo.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * atom_trajectoryparticleinfo.cpp
@@ -6,4 +13,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,5 +24,7 @@
 /** Constructor of class TrajectoryParticleInfo.
  */
-TrajectoryParticleInfo::TrajectoryParticleInfo() : FixedIon(0) {};
+TrajectoryParticleInfo::TrajectoryParticleInfo() :
+  FixedIon(0)
+{};
 
 /** Destructor of class TrajectoryParticleInfo.
Index: src/atom_trajectoryparticleinfo.hpp
===================================================================
--- src/atom_trajectoryparticleinfo.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_trajectoryparticleinfo.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -20,6 +20,6 @@
 #include <vector>
 
-#include "vector.hpp"
-#include "VectorSet.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/VectorSet.hpp"
 
 /********************************************** declarations *******************************/
@@ -36,5 +36,5 @@
 
   TrajectoryParticleInfo();
-  ~TrajectoryParticleInfo();
+  virtual ~TrajectoryParticleInfo();
 
 private:
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/bond.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /** \file bond.cpp
  * 
@@ -5,7 +12,13 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "atom.hpp"
 #include "bond.hpp"
@@ -18,9 +31,16 @@
 /** Empty Constructor for class bond.
  */
-bond::bond()
-  : leftatom(NULL), rightatom(NULL), previous(NULL), next(NULL), HydrogenBond(0),
-    BondDegree(0), nr(-1), Cyclic(false), Type(Undetermined), Used(white)
-{
-};
+bond::bond() :
+  leftatom(NULL),
+  rightatom(NULL),
+  previous(NULL),
+  next(NULL),
+  HydrogenBond(0),
+  BondDegree(0),
+  nr(-1),
+  Cyclic(false),
+  Type(Undetermined),
+  Used(white)
+{};
 
 /** Constructor for class bond, taking right and left bond partner
@@ -30,12 +50,20 @@
  * \param number increasing index
  */
-bond::bond(atom *left, atom *right, const int degree, const int number)
-  : leftatom(left), rightatom(right), previous(NULL), next(NULL), HydrogenBond(0),
-    BondDegree(degree), nr(number), Cyclic(false), Type(Undetermined), Used(white)
+bond::bond(atom *left, atom *right, const int degree, const int number) :
+  leftatom(left),
+  rightatom(right),
+  previous(NULL),
+  next(NULL),
+  HydrogenBond(0),
+  BondDegree(degree),
+  nr(number),
+  Cyclic(false),
+  Type(Undetermined),
+  Used(white)
 {
   if ((left != NULL) && (right != NULL)) {
-    if ((left->type != NULL) && (left->type->Z == 1))
+    if ((left->getType() != NULL) && (left->getType()->getAtomicNumber() == 1))
       HydrogenBond++;
-    if ((right->type != NULL) && (right->type->Z == 1))
+    if ((right->getType() != NULL) && (right->getType()->getAtomicNumber() == 1))
       HydrogenBond++;
   }
@@ -126,5 +154,5 @@
 double bond::GetDistance() const
 {
-  return (leftatom->node->distance(*rightatom->node));
+  return (leftatom->distance(*rightatom));
 };
 
@@ -134,4 +162,4 @@
 double bond::GetDistanceSquared() const
 {
-  return (leftatom->node->DistanceSquared(*rightatom->node));
+  return (leftatom->DistanceSquared(*rightatom));
 };
Index: src/bondgraph.cpp
===================================================================
--- src/bondgraph.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/bondgraph.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * bondgraph.cpp
@@ -6,4 +13,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -14,18 +26,22 @@
 #include "bondgraph.hpp"
 #include "element.hpp"
-#include "info.hpp"
-#include "verbose.hpp"
-#include "log.hpp"
+#include "Helpers/Info.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "parser.hpp"
 #include "periodentafel.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+const double BondGraph::BondThreshold = 0.4;   //!< CSD threshold in bond check which is the width of the interval whose center is the sum of the covalent radii
 
 /** Constructor of class BondGraph.
  * This classes contains typical bond lengths and thus may be used to construct a bond graph for a given molecule.
  */
-BondGraph::BondGraph(bool IsA) : BondLengthMatrix(NULL), max_distance(0), IsAngstroem(IsA)
-{
-};
+BondGraph::BondGraph(bool IsA) :
+    BondLengthMatrix(NULL),
+    max_distance(0),
+    IsAngstroem(IsA)
+{};
 
 /** Destructor of class BondGraph.
@@ -73,4 +89,5 @@
           max_distance = TempContainer->Matrix[0][i][j];
   }
+  max_distance += BondThreshold;
 
   if (status) // set to not NULL only if matrix was parsed
@@ -128,11 +145,21 @@
 
   for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
-    if ((*iter)->type->CovalentRadius > max_distance)
-      max_distance = (*iter)->type->CovalentRadius;
+    if ((*iter)->getType()->getCovalentRadius() > max_distance)
+      max_distance = (*iter)->getType()->getCovalentRadius();
   }
   max_distance *= 2.;
+  max_distance += BondThreshold;
 
   return max_distance;
 };
+
+/** Returns the maximum distance (e.g. necessary for LinkedCell).
+ * \return BondGraph::max_distance
+ */
+double BondGraph::getMaxDistance() const
+{
+  return max_distance;
+}
+
 
 /** Returns bond criterion for given pair based on covalent radius.
@@ -145,8 +172,8 @@
 void BondGraph::CovalentMinMaxDistance(BondedParticle * const Walker, BondedParticle * const OtherWalker, double &MinDistance, double &MaxDistance, bool IsAngstroem)
 {
-  MinDistance = OtherWalker->type->CovalentRadius + Walker->type->CovalentRadius;
+  MinDistance = OtherWalker->getType()->getCovalentRadius() + Walker->getType()->getCovalentRadius();
   MinDistance *= (IsAngstroem) ? 1. : 1. / AtomicLengthToAngstroem;
-  MaxDistance = MinDistance + BONDTHRESHOLD;
-  MinDistance -= BONDTHRESHOLD;
+  MaxDistance = MinDistance + BondThreshold;
+  MinDistance -= BondThreshold;
 };
 
@@ -166,8 +193,8 @@
     CovalentMinMaxDistance(Walker, OtherWalker, MinDistance, MaxDistance, IsAngstroem);
   } else {
-    MinDistance = GetBondLength(Walker->type->Z-1, OtherWalker->type->Z-1);
+    MinDistance = GetBondLength(Walker->getType()->getAtomicNumber()-1, OtherWalker->getType()->getAtomicNumber()-1);
     MinDistance *= (IsAngstroem) ? 1. : 1. / AtomicLengthToAngstroem;
-    MaxDistance = MinDistance + BONDTHRESHOLD;
-    MinDistance -= BONDTHRESHOLD;
-  }
-};
+    MaxDistance = MinDistance + BondThreshold;
+    MinDistance -= BondThreshold;
+  }
+};
Index: src/bondgraph.hpp
===================================================================
--- src/bondgraph.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/bondgraph.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -20,7 +20,4 @@
 #include <iosfwd>
 
-/*********************************************** defines ***********************************/
-
-#define BONDTHRESHOLD 0.4   //!< CSD threshold in bond check which is the width of the interval whose center is the sum of the covalent radii
 
 /****************************************** forward declarations *****************************/
@@ -47,5 +44,9 @@
   void CovalentMinMaxDistance(BondedParticle * const Walker, BondedParticle * const OtherWalker, double &MinDistance, double &MaxDistance, bool IsAngstroem);
 
+  double getMaxDistance() const;
+
 private:
+  static const double BondThreshold;
+
   MatrixContainer *BondLengthMatrix;
   double max_distance;
Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/boundary.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /** \file boundary.cpp
  *
@@ -4,6 +11,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
+#include "Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp"
+#include "BoundaryPointSet.hpp"
+#include "BoundaryLineSet.hpp"
+#include "BoundaryTriangleSet.hpp"
+#include "CandidateForTesselation.hpp"
+//#include "TesselPoint.hpp"
 #include "World.hpp"
 #include "atom.hpp"
@@ -12,15 +30,15 @@
 #include "config.hpp"
 #include "element.hpp"
-#include "helpers.hpp"
-#include "info.hpp"
+#include "Helpers/helpers.hpp"
+#include "Helpers/Info.hpp"
 #include "linkedcell.hpp"
-#include "verbose.hpp"
-#include "log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "tesselation.hpp"
 #include "tesselationhelpers.hpp"
 #include "World.hpp"
-#include "Plane.hpp"
-#include "Matrix.hpp"
+#include "LinearAlgebra/Plane.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "Box.hpp"
 
@@ -86,5 +104,5 @@
               if (Neighbour == BoundaryPoints[axis].end()) // make it wrap around
                 Neighbour = BoundaryPoints[axis].begin();
-              DistanceVector = runner->second.second->x - Neighbour->second.second->x;
+              DistanceVector = (runner->second.second->getPosition()) - (Neighbour->second.second->getPosition());
               do { // seek for neighbour pair where it flips
                   OldComponent = DistanceVector[Othercomponent];
@@ -92,5 +110,5 @@
                   if (Neighbour == BoundaryPoints[axis].end()) // make it wrap around
                     Neighbour = BoundaryPoints[axis].begin();
-                  DistanceVector = runner->second.second->x - Neighbour->second.second->x;
+                  DistanceVector = (runner->second.second->getPosition()) - (Neighbour->second.second->getPosition());
                   //Log() << Verbose(2) << "OldComponent is " << OldComponent << ", new one is " << DistanceVector.x[Othercomponent] << "." << endl;
                 } while ((runner != Neighbour) && (fabs(OldComponent / fabs(
@@ -104,5 +122,5 @@
                   //Log() << Verbose(1) << "The pair, where the sign of OtherComponent flips, is: " << *(Neighbour->second.second) << " and " << *(OtherNeighbour->second.second) << "." << endl;
                   // now we have found the pair: Neighbour and OtherNeighbour
-                  OtherVector = runner->second.second->x - OtherNeighbour->second.second->x;
+                  OtherVector = (runner->second.second->getPosition()) - (OtherNeighbour->second.second->getPosition());
                   //Log() << Verbose(1) << "Distances to Neighbour and OtherNeighbour are " << DistanceVector.x[component] << " and " << OtherVector.x[component] << "." << endl;
                   //Log() << Verbose(1) << "OtherComponents to Neighbour and OtherNeighbour are " << DistanceVector.x[Othercomponent] << " and " << OtherVector.x[Othercomponent] << "." << endl;
@@ -172,5 +190,5 @@
     // 3b. construct set of all points, transformed into cylindrical system and with left and right neighbours
     for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
-      ProjectedVector = (*iter)->x - (*MolCenter);
+      ProjectedVector = (*iter)->getPosition() - (*MolCenter);
       ProjectedVector.ProjectOntoPlane(AxisVector);
 
@@ -187,5 +205,5 @@
       }
     DoLog(1) && (Log() << Verbose(1) << "Inserting " << **iter << ": (r, alpha) = (" << radius << "," << angle << "): " << ProjectedVector << endl);
-      BoundaryTestPair = BoundaryPoints[axis].insert(BoundariesPair(angle, DistancePair (radius, (*iter))));
+      BoundaryTestPair = BoundaryPoints[axis].insert(BoundariesPair(angle, TesselPointDistancePair (radius, (*iter))));
       if (!BoundaryTestPair.second) { // same point exists, check first r, then distance of original vectors to center of gravity
         DoLog(2) && (Log() << Verbose(2) << "Encountered two vectors whose projection onto axis " << axis << " is equal: " << endl);
@@ -198,8 +216,7 @@
           DoLog(2) && (Log() << Verbose(2) << "Keeping new vector due to larger projected distance " << ProjectedVectorNorm << "." << endl);
         } else if (fabs(ProjectedVectorNorm - BoundaryTestPair.first->second.first) < MYEPSILON) {
-          helper = (*iter)->x;
-          helper -= *MolCenter;
+          helper = (*iter)->getPosition() - (*MolCenter);
           const double oldhelperNorm = helper.NormSquared();
-          helper = BoundaryTestPair.first->second.second->x - (*MolCenter);
+          helper = BoundaryTestPair.first->second.second->getPosition() - (*MolCenter);
           if (helper.NormSquared() < oldhelperNorm) {
             BoundaryTestPair.first->second.second = (*iter);
@@ -254,17 +271,17 @@
         {
           Vector SideA, SideB, SideC, SideH;
-          SideA = left->second.second->x - (*MolCenter);
+          SideA = left->second.second->getPosition() - (*MolCenter);
           SideA.ProjectOntoPlane(AxisVector);
           //          Log() << Verbose(1) << "SideA: " << SideA << endl;
 
-          SideB = right->second.second->x -(*MolCenter);
+          SideB = right->second.second->getPosition() -(*MolCenter);
           SideB.ProjectOntoPlane(AxisVector);
           //          Log() << Verbose(1) << "SideB: " << SideB << endl;
 
-          SideC = left->second.second->x - right->second.second->x;
+          SideC = left->second.second->getPosition() - right->second.second->getPosition();
           SideC.ProjectOntoPlane(AxisVector);
           //          Log() << Verbose(1) << "SideC: " << SideC << endl;
 
-          SideH = runner->second.second->x -(*MolCenter);
+          SideH = runner->second.second->getPosition() -(*MolCenter);
           SideH.ProjectOntoPlane(AxisVector);
           //          Log() << Verbose(1) << "SideH: " << SideH << endl;
@@ -674,11 +691,12 @@
   double cellvolume = 0.;
 
-  // transform to PAS
-  mol->PrincipalAxisSystem(true);
+  // transform to PAS by Action
+  Vector MainAxis(0.,0.,1.);
+  MoleculeRotateToPrincipalAxisSystem(MainAxis);
 
   IsAngstroem = configuration->GetIsAngstroem();
   BoundaryPoints = GetBoundaryPoints(mol, TesselStruct);
   GreatestDiameter = GetDiametersOfCluster(BoundaryPoints, mol, TesselStruct, IsAngstroem);
-  LinkedCell *LCList = new LinkedCell(mol, 10.);
+  LinkedCell *LCList = new LinkedCell(*mol, 10.);
   FindConvexBorder(mol, BoundaryPoints, TesselStruct, (const LinkedCell *&)LCList, NULL);
   delete (LCList);
@@ -699,5 +717,5 @@
   // sum up the atomic masses
   for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
-      totalmass += (*iter)->type->mass;
+      totalmass += (*iter)->getType()->getMass();
   }
   DoLog(0) && (Log() << Verbose(0) << "RESULT: The summed mass is " << setprecision(10) << totalmass << " atomicmassunit." << endl);
@@ -790,5 +808,5 @@
     if ((*ListRunner)->getAtomCount() > 0) {
       DoLog(1) && (Log() << Verbose(1) << "Pre-creating linked cell lists for molecule " << *ListRunner << "." << endl);
-      LCList[(*ListRunner)] = new LinkedCell((*ListRunner), 10.); // get linked cell list
+      LCList[(*ListRunner)] = new LinkedCell(*(*ListRunner), 10.); // get linked cell list
       DoLog(1) && (Log() << Verbose(1) << "Pre-creating tesselation for molecule " << *ListRunner << "." << endl);
       TesselStruct[(*ListRunner)] = NULL;
@@ -798,5 +816,4 @@
   // Center filler at origin
   filler->CenterEdge(&Inserter);
-  filler->Center.Zero();
   const int FillerCount = filler->getAtomCount();
   DoLog(2) && (Log() << Verbose(2) << "INFO: Filler molecule has the following bonds:" << endl);
@@ -855,5 +872,5 @@
 
           // ... and put at new position
-          Inserter = (*iter)->x;
+          Inserter = (*iter)->getPosition();
           if (DoRandomRotation)
             Inserter *= Rotations;
@@ -880,7 +897,7 @@
             // copy atom ...
             CopyAtoms[(*iter)->nr] = (*iter)->clone();
-            CopyAtoms[(*iter)->nr]->x = Inserter;
+            (*CopyAtoms[(*iter)->nr]).setPosition(Inserter);
             Filling->AddAtom(CopyAtoms[(*iter)->nr]);
-            DoLog(4) && (Log() << Verbose(4) << "Filling atom " << **iter << ", translated to " << AtomTranslations << ", at final position is " << (CopyAtoms[(*iter)->nr]->x) << "." << endl);
+            DoLog(1) && (Log() << Verbose(1) << "Filling atom " << **iter << ", translated to " << AtomTranslations << ", at final position is " << (CopyAtoms[(*iter)->nr]->getPosition()) << "." << endl);
           } else {
             DoLog(1) && (Log() << Verbose(1) << "INFO: Position at " << Inserter << " is inner point, within boundary or outside of MaxDistance." << endl);
@@ -940,5 +957,5 @@
   // initialise Linked Cell
   if (LCList == NULL) {
-    LCList = new LinkedCell(mol, 2.*RADIUS);
+    LCList = new LinkedCell(*mol, 2.*RADIUS);
     freeLC = true;
   }
Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/boundary.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,6 +1,4 @@
 #ifndef BOUNDARY_HPP_
 #define BOUNDARY_HPP_
-
-using namespace std;
 
 /*********************************************** includes ***********************************/
@@ -18,8 +16,8 @@
 
 #include "defs.hpp"
+#include "BoundaryMaps.hpp"
 
 /****************************************** forward declarations *****************************/
 
-class atom;
 class BoundaryPointSet;
 class BoundaryLineSet;
@@ -30,19 +28,12 @@
 class MoleculeListClass;
 class Tesselation;
+class TesselPoint;
 class Vector;
 
 /********************************************** definitions *********************************/
 
-#define DEBUG 1
-#define DoSingleStepOutput 0
-#define SingleStepWidth 10
-
-#define DistancePair pair < double, atom* >
-#define DistanceMap multimap < double, atom* >
-#define DistanceTestPair pair < DistanceMap::iterator, bool>
-
-#define Boundaries map <double, DistancePair >
-#define BoundariesPair pair<double, DistancePair >
-#define BoundariesTestPair pair< Boundaries::iterator, bool>
+enum { DEBUG=1 };
+enum { DoSingleStepOutput=0 };
+enum { SingleStepWidth=10 };
 
 /********************************************** declarations *******************************/
@@ -52,5 +43,4 @@
 void FindConvexBorder(const molecule* const mol, Boundaries *BoundaryPts, Tesselation *&TesselStruct, const LinkedCell *LCList, const char *filename);
 Vector* FindEmbeddingHole(MoleculeListClass *mols, molecule *srcmol);
-void FindNextSuitablePoint(class BoundaryTriangleSet *BaseTriangle, class BoundaryLineSet *BaseLine, atom*& OptCandidate, Vector *OptCandidateCenter, double *ShortestAngle, const double RADIUS, LinkedCell *LC);
 bool FindNonConvexBorder(const molecule* const mol, Tesselation *&TesselStruct, const LinkedCell *&LC, const double RADIUS, const char *tempbasename);
 Boundaries *GetBoundaryPoints(const molecule *mol, Tesselation *&TesselStruct);
